/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2007  X.Vassilakos
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.gui.active_learning;

import ipl.util.Constants;
import ipl.nerc.active_learning.ActiveLearning;
import java.applet.Applet;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import javax.swing.JApplet;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 *
 * @author   
 */
public class ParamsForm extends javax.swing.JFrame {
    
    /**The main active learning frame that created this paraeters form*/
    private final Form actLeFrm;
    /**A JFileChooser for loading paths by the user*/
    private JFileChooser jfch;
    
    
    private int batchSize;
    /** Creates new form parametersFrame */
    
    public ParamsForm(Form  actLeFrmIn) {
        
        
        initComponents();
        
        new File(Constants.FP_PERSON_CLASSIFIER_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_PERSON_CLASSIFIER_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.FP_ORGANIZATION_CLASSIFIER_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_ORGANIZATION_CLASSIFIER_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SENTENCE_SPLITTER_CLASSIFIER_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.FP_USED_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.FP_PER_AMBIGUOUS_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.FP_ORG_AMBIGUOUS_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.FP_VECTORS_INFO_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_USED_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_PER_AMBIGUOUS_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_ORG_AMBIGUOUS_VECTORS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.SP_VECTORS_INFO_FILE_PATH).getParentFile().mkdirs();
        
        ////////////////////////////// tab4 ////////////////////////////////////
        new File(Constants.LISTS_DIRECTORY_PATH).getParentFile().mkdirs();
       // new File(Constants.TIMEX_PATERNS_FILE_PATH).getParentFile().mkdirs();
        new File(Constants.ACTIVE_LEARNING_POOL_OF_FILES_DIR_PATH).getParentFile().mkdirs();
        new File(Constants.FILES_DIR_PATH).getParentFile().mkdirs();
        
        
        
        setResizable(true);
        setDefaultValues();
        /**ActiveLearningFrame which creates and calls this parameters form*/
        actLeFrm = actLeFrmIn;
        setTitle("Parameters");
        
        jfch = new JFileChooser();
        jfch.setMultiSelectionEnabled(false);
        
        
        
    }//ParamFrame constructor
    
    /**
     * Method for setting paths and other parameters to default*/
    private void setDefaultValues(){
        
        
        try {
            ////////////////////////////////////////////////////////////////////////
            ///////////Initializing JtextFields with default paths//////////////////
            ///////////stated as static members of class "Constants"////////////////
            
            ///////////////////////////////tab1/////////////////////////////////////
            // loading paths for classifiers
            FPPerClassifierFileNameTxt.setText(new File(Constants.FP_PERSON_CLASSIFIER_FILE_PATH).getCanonicalPath());
            SPPerClassifierFileNameTxt.setText(new File(Constants.SP_PERSON_CLASSIFIER_FILE_PATH).getCanonicalPath());
            FPOrgClassifierFileNameTxt.setText(new File(Constants.FP_ORGANIZATION_CLASSIFIER_FILE_PATH).getCanonicalPath());
            SPOrgClassifierFileNameTxt.setText(new File(Constants.SP_ORGANIZATION_CLASSIFIER_FILE_PATH).getCanonicalPath());
            sentenceSplitterModelFileNameTxt.setText(new File(
                    Constants.SENTENCE_SPLITTER_CLASSIFIER_FILE_PATH).getCanonicalPath());
            ////////////////////////////// tabs 2,3 ////////////////////////////////////
            FPusedVectorsFileNameTxt.setText(new File(Constants.FP_USED_VECTORS_FILE_PATH).getCanonicalPath());
            FPPERambiguousVectorsFileNameTxt.setText(new File(Constants.FP_PER_AMBIGUOUS_VECTORS_FILE_PATH).getCanonicalPath());
            FPORGambiguousVectorsFileNameTxt.setText(new File(Constants.FP_ORG_AMBIGUOUS_VECTORS_FILE_PATH).getCanonicalPath());
            FPvectorsInformationsFileNameTxt.setText(new File(Constants.FP_VECTORS_INFO_FILE_PATH).getCanonicalPath());
            SPusedVectorsFileNameTxt.setText(new File(Constants.SP_USED_VECTORS_FILE_PATH).getCanonicalPath());
            SPPERambiguousVectorsFileNameTxt.setText(new File(Constants.SP_PER_AMBIGUOUS_VECTORS_FILE_PATH).getCanonicalPath());
            SPORGambiguousVectorsFileNameTxt.setText(new File(Constants.SP_ORG_AMBIGUOUS_VECTORS_FILE_PATH).getCanonicalPath());
            SPvectorsInformationsFileNameTxt.setText(new File(Constants.SP_VECTORS_INFO_FILE_PATH).getCanonicalPath());
            
            ////////////////////////////// tab4 ////////////////////////////////////
            listsDirectoryTxt.setText(new File(Constants.LISTS_DIRECTORY_PATH).getCanonicalPath());
            //timexPatternsFileNameTxt.setText(new File(Constants.TIMEX_PATERNS_FILE_PATH).getCanonicalPath());
            activeLearningFilesDirectoryTxt.setText(new File(
                    Constants.ACTIVE_LEARNING_POOL_OF_FILES_DIR_PATH).getCanonicalPath());
            testFilesDirectoryTxt.setText(new File(Constants.ACTIVE_LEARNING_TEST_DIR).getCanonicalPath());
        } catch (IOException ex) {
            ex.printStackTrace();
        }
       batchSize = 400;
        batchSizeTxt.setText(String.valueOf(batchSize));
        
        //==========Initializing JtextFields with default paths=================
        //========stated as static members of class "Constants"=================
        //======================================================================
        
                       
    }
    
    public int batchSize(){
        try {
            
            batchSize = Integer.parseInt(batchSizeTxt.getText());
            
        } catch (NumberFormatException ex) {
            ex.printStackTrace();
        }
        
        return (batchSize);
        
    }
    
    /**
     * Method to be called from other methods, performing actions when a browse
     * button is clicked by the user, in order to load  a path for a file
     */
    private void doOnBrowseClickFile(JTextField txt) {
        
        jfch.setFileSelectionMode(jfch.FILES_ONLY);
        File f = new File(txt.getText());
        
        if (f.exists()){
            
            if(f.isDirectory())
                jfch.setCurrentDirectory(f);
            else
                jfch.setCurrentDirectory(f.getParentFile());
            
        }else
            JOptionPane.showMessageDialog(
                    null,f.toString()+
                    " does not exist","File does not exist",
                    JOptionPane.INFORMATION_MESSAGE);
        
        if(jfch.APPROVE_OPTION==jfch.showDialog(null,"Set file"))
            txt.setText(jfch.getSelectedFile().toString());
        
    }//doOnBrowseClickFile
    
    /**
     * Method to be called from other methods, performing actions when a browse
     * button is clicked by the user, in order to load  a path for a Directory
     */
    private void doOnBrowseClickDir(JTextField txt){
        
        jfch.setFileSelectionMode(jfch.DIRECTORIES_ONLY);
        
        File f = new File(txt.getText());
        
        if (f.exists()){
            
            if(f.isDirectory())
                jfch.setCurrentDirectory(f);
            else
                jfch.setCurrentDirectory(f.getParentFile());
            
        } else JOptionPane.showMessageDialog(null,f.toString()+
                " does not exist","",JOptionPane.INFORMATION_MESSAGE);
        
        if(jfch.APPROVE_OPTION==jfch.showDialog(null,"Set Directory")){
            txt.setText(jfch.getSelectedFile().toString());
            
        }
        
    }//doOnBrowseClickDir
    
    private void change2NextPath(JTextField pathfield){
        
        String path = pathfield.getText();
        String suffix = "";
        int length = path.length();
        if (path.endsWith("txt")){
            
            suffix = ".txt";
            pathfield.setText(path.substring(0, length - 4));
            path = pathfield.getText();
            length = path.length();
            
        }
        
        
        if (path.endsWith("/")||path.endsWith("\\")){
            
            suffix = path.substring(path.length() - 1,path.length());
            pathfield.setText(path.substring(0, length - 1));
            path = pathfield.getText();
            length = path.length();
            
        }
        
        String num = path.substring(length - 2);
        
        
        
        try {
            
            int nextNum = Integer.parseInt(num);
            nextNum = (nextNum%10)+1;
            String repl = String.valueOf(nextNum);
            String numRepl = (repl.length() == 1)? "0".concat(repl) :repl;
            path = path.substring(0,length - 2).concat(numRepl);
            pathfield.setText(path + suffix);
            
            
        } catch (NumberFormatException ex) {
            
            JOptionPane.showMessageDialog(null, pathfield.getText() + ":\n"+num);
            
            ex.printStackTrace();
            
        }
        
        
        
        
    }
    
              
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        actLeMethodGrp = new javax.swing.ButtonGroup();
        howToFindPoolGrp = new javax.swing.ButtonGroup();
        howToFindTestGrp = new javax.swing.ButtonGroup();
        paramTabs = new javax.swing.JTabbedPane();
        classifiersPathPnl = new javax.swing.JPanel();
        jLabel23 = new javax.swing.JLabel();
        FPPerClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        SPPerClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        FPOrgClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        SPOrgClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        sentenceSplitterModelFileNameTxt = new javax.swing.JTextField();
        secondPassPanl = new javax.swing.JPanel();
        jLabel15 = new javax.swing.JLabel();
        FPusedVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        FPPERambiguousVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel26 = new javax.swing.JLabel();
        FPORGambiguousVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        FPvectorsInformationsFileNameTxt = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        SPusedVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        SPPERambiguousVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel27 = new javax.swing.JLabel();
        SPORGambiguousVectorsFileNameTxt = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        SPvectorsInformationsFileNameTxt = new javax.swing.JTextField();
        restPnl = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        listsDirectoryTxt = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        activeLearningFilesDirectoryTxt = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        testFilesDirectoryTxt = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        batchSizeTxt = new javax.swing.JTextField();
        jPanel12 = new javax.swing.JPanel();
        jPanel19 = new javax.swing.JPanel();
        browsePathBut = new javax.swing.JButton();
        jPanel20 = new javax.swing.JPanel();
        jPanel17 = new javax.swing.JPanel();
        restoreDefaultBut = new javax.swing.JButton();
        jPanel18 = new javax.swing.JPanel();
        okB = new javax.swing.JButton();

        FormListener formListener = new FormListener();

        setTitle("Change Paths");
        paramTabs.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        paramTabs.setTabPlacement(javax.swing.JTabbedPane.BOTTOM);
        classifiersPathPnl.setLayout(new java.awt.GridLayout(10, 1, 0, 5));

        classifiersPathPnl.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 3));
        classifiersPathPnl.addMouseListener(formListener);

        jLabel23.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel23.setText("PERSON classifier for first pass");
        jLabel23.setToolTipText("As Defind for First Pass");
        jLabel23.setAlignmentY(0.0F);
        jLabel23.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        classifiersPathPnl.add(jLabel23);

        FPPerClassifierFileNameTxt.addMouseListener(formListener);

        classifiersPathPnl.add(FPPerClassifierFileNameTxt);

        jLabel24.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel24.setText("PERSON classifier for second pass");
        classifiersPathPnl.add(jLabel24);

        SPPerClassifierFileNameTxt.addMouseListener(formListener);

        classifiersPathPnl.add(SPPerClassifierFileNameTxt);

        jLabel22.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel22.setText("ORGANIZATION classifier for first pass");
        jLabel22.setToolTipText("As Defind for First Pass");
        classifiersPathPnl.add(jLabel22);

        FPOrgClassifierFileNameTxt.addMouseListener(formListener);

        classifiersPathPnl.add(FPOrgClassifierFileNameTxt);

        jLabel20.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel20.setText("ORGANIZATION classifier for second pass");
        classifiersPathPnl.add(jLabel20);

        SPOrgClassifierFileNameTxt.addMouseListener(formListener);

        classifiersPathPnl.add(SPOrgClassifierFileNameTxt);

        jLabel18.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel18.setText("Sentence splitter");
        classifiersPathPnl.add(jLabel18);

        sentenceSplitterModelFileNameTxt.addMouseListener(formListener);

        classifiersPathPnl.add(sentenceSplitterModelFileNameTxt);

        paramTabs.addTab("Classifiers", classifiersPathPnl);

        secondPassPanl.setLayout(new java.awt.GridLayout(10, 1, 0, 5));

        secondPassPanl.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 3));
        jLabel15.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel15.setText("Used vectors");
        secondPassPanl.add(jLabel15);

        FPusedVectorsFileNameTxt.addMouseListener(formListener);

        secondPassPanl.add(FPusedVectorsFileNameTxt);

        jLabel14.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel14.setText("PERSON ambiguous vectors");
        secondPassPanl.add(jLabel14);

        FPPERambiguousVectorsFileNameTxt.addMouseListener(formListener);

        secondPassPanl.add(FPPERambiguousVectorsFileNameTxt);

        jLabel26.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel26.setText("ORGANIZATION ambiguous vectors");
        secondPassPanl.add(jLabel26);

        FPORGambiguousVectorsFileNameTxt.addMouseListener(formListener);

        secondPassPanl.add(FPORGambiguousVectorsFileNameTxt);

        jLabel12.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel12.setText("Vectors information for first pass");
        secondPassPanl.add(jLabel12);

        FPvectorsInformationsFileNameTxt.addMouseListener(formListener);

        secondPassPanl.add(FPvectorsInformationsFileNameTxt);

        paramTabs.addTab("Firts Pass", secondPassPanl);

        jPanel1.setLayout(new java.awt.GridLayout(10, 1, 0, 5));

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 3));
        jLabel11.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel11.setText("Used vectors");
        jPanel1.add(jLabel11);

        SPusedVectorsFileNameTxt.addMouseListener(formListener);

        jPanel1.add(SPusedVectorsFileNameTxt);

        jLabel10.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel10.setText("PERSON ambiguous vectors");
        jPanel1.add(jLabel10);

        SPPERambiguousVectorsFileNameTxt.addMouseListener(formListener);

        jPanel1.add(SPPERambiguousVectorsFileNameTxt);

        jLabel27.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel27.setText("ORGANIZATION ambiguous vectors");
        jPanel1.add(jLabel27);

        SPORGambiguousVectorsFileNameTxt.addMouseListener(formListener);

        jPanel1.add(SPORGambiguousVectorsFileNameTxt);

        jLabel13.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel13.setText("Vectors information for second pass");
        jPanel1.add(jLabel13);

        SPvectorsInformationsFileNameTxt.addMouseListener(formListener);

        jPanel1.add(SPvectorsInformationsFileNameTxt);

        paramTabs.addTab("Second Pass", jPanel1);

        restPnl.setLayout(new java.awt.GridBagLayout());

        restPnl.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 3));
        jLabel16.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel16.setText("Lists directory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(jLabel16, gridBagConstraints);

        listsDirectoryTxt.setMaximumSize(new java.awt.Dimension(500, 25));
        listsDirectoryTxt.addMouseListener(formListener);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 59;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 7.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(listsDirectoryTxt, gridBagConstraints);

        jLabel21.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel21.setText("Active learning files directory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(jLabel21, gridBagConstraints);

        activeLearningFilesDirectoryTxt.setMaximumSize(new java.awt.Dimension(500, 25));
        activeLearningFilesDirectoryTxt.addMouseListener(formListener);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 59;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 7.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(activeLearningFilesDirectoryTxt, gridBagConstraints);

        jLabel25.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel25.setText("Test files directory ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(jLabel25, gridBagConstraints);

        testFilesDirectoryTxt.setMaximumSize(new java.awt.Dimension(500, 25));
        testFilesDirectoryTxt.addMouseListener(formListener);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 59;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 7.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(14, 8, 2, 2);
        restPnl.add(testFilesDirectoryTxt, gridBagConstraints);

        jPanel5.setLayout(new java.awt.GridBagLayout());

        jLabel19.setFont(new java.awt.Font("Arial Black", 1, 14));
        jLabel19.setText("batch size:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(7, 7, 7, 7);
        jPanel5.add(jLabel19, gridBagConstraints);

        batchSizeTxt.setColumns(3);
        batchSizeTxt.setFont(new java.awt.Font("Arial Black", 1, 13));
        batchSizeTxt.addKeyListener(formListener);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 6.0;
        gridBagConstraints.weighty = 1.0;
        jPanel5.add(batchSizeTxt, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(17, 11, 5, 5);
        restPnl.add(jPanel5, gridBagConstraints);

        paramTabs.addTab("Rest Paths", restPnl);

        getContentPane().add(paramTabs, java.awt.BorderLayout.CENTER);

        jPanel12.setLayout(new java.awt.GridLayout(2, 1, 0, 10));

        jPanel19.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        browsePathBut.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browsePathBut.setToolTipText("browse");
        browsePathBut.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browsePathBut.setEnabled(false);
        browsePathBut.addActionListener(formListener);

        jPanel19.add(browsePathBut);
        browsePathBut.getAccessibleContext().setAccessibleDescription("");

        jPanel12.add(jPanel19);

        jPanel20.setLayout(new java.awt.GridLayout(1, 2));

        jPanel17.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        restoreDefaultBut.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/default_val01.jpg")));
        restoreDefaultBut.setText("Default");
        restoreDefaultBut.setToolTipText("Restore all parameter values  to default");
        restoreDefaultBut.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))));
        restoreDefaultBut.addActionListener(formListener);

        jPanel17.add(restoreDefaultBut);

        jPanel20.add(jPanel17);

        jPanel18.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        okB.setFont(new java.awt.Font("Book Antiqua", 1, 13));
        okB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/ok_02.gif")));
        okB.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 102, 0))));
        okB.addActionListener(formListener);

        jPanel18.add(okB);

        jPanel20.add(jPanel18);

        jPanel12.add(jPanel20);

        getContentPane().add(jPanel12, java.awt.BorderLayout.SOUTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-582)/2, (screenSize.height-394)/2, 582, 394);
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener, java.awt.event.KeyListener, java.awt.event.MouseListener {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == browsePathBut) {
                ParamsForm.this.browsePathButActionPerformed(evt);
            }
            else if (evt.getSource() == restoreDefaultBut) {
                ParamsForm.this.restoreDefaultButActionPerformed(evt);
            }
            else if (evt.getSource() == okB) {
                ParamsForm.this.okBActionPerformed(evt);
            }
        }

        public void keyPressed(java.awt.event.KeyEvent evt) {
        }

        public void keyReleased(java.awt.event.KeyEvent evt) {
        }

        public void keyTyped(java.awt.event.KeyEvent evt) {
            if (evt.getSource() == batchSizeTxt) {
                ParamsForm.this.batchSizeTxtKeyTyped(evt);
            }
        }

        public void mouseClicked(java.awt.event.MouseEvent evt) {
            if (evt.getSource() == classifiersPathPnl) {
                ParamsForm.this.classifiersPathPnlMouseClicked(evt);
            }
            else if (evt.getSource() == FPPerClassifierFileNameTxt) {
                ParamsForm.this.FPPerClassifierFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPPerClassifierFileNameTxt) {
                ParamsForm.this.SPPerClassifierFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == FPOrgClassifierFileNameTxt) {
                ParamsForm.this.FPOrgClassifierFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPOrgClassifierFileNameTxt) {
                ParamsForm.this.SPOrgClassifierFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == sentenceSplitterModelFileNameTxt) {
                ParamsForm.this.sentenceSplitterModelFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == FPusedVectorsFileNameTxt) {
                ParamsForm.this.FPusedVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == FPPERambiguousVectorsFileNameTxt) {
                ParamsForm.this.FPPERambiguousVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == FPORGambiguousVectorsFileNameTxt) {
                ParamsForm.this.FPORGambiguousVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == FPvectorsInformationsFileNameTxt) {
                ParamsForm.this.FPvectorsInformationsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPusedVectorsFileNameTxt) {
                ParamsForm.this.SPusedVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPPERambiguousVectorsFileNameTxt) {
                ParamsForm.this.SPPERambiguousVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPORGambiguousVectorsFileNameTxt) {
                ParamsForm.this.SPORGambiguousVectorsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == SPvectorsInformationsFileNameTxt) {
                ParamsForm.this.SPvectorsInformationsFileNameTxtMouseClicked(evt);
            }
            else if (evt.getSource() == listsDirectoryTxt) {
                ParamsForm.this.listsDirectoryTxtMouseClicked(evt);
            }
            else if (evt.getSource() == activeLearningFilesDirectoryTxt) {
                ParamsForm.this.activeLearningFilesDirectoryTxtMouseClicked(evt);
            }
            else if (evt.getSource() == testFilesDirectoryTxt) {
                ParamsForm.this.testFilesDirectoryTxtMouseClicked(evt);
            }
        }

        public void mouseEntered(java.awt.event.MouseEvent evt) {
        }

        public void mouseExited(java.awt.event.MouseEvent evt) {
        }

        public void mousePressed(java.awt.event.MouseEvent evt) {
        }

        public void mouseReleased(java.awt.event.MouseEvent evt) {
        }
    }// </editor-fold>//GEN-END:initComponents
    
    private void SPvectorsInformationsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPvectorsInformationsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPvectorsInformationsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPvectorsInformationsFileNameTxtMouseClicked
                                                        
    private void restoreDefaultButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_restoreDefaultButActionPerformed
        
          JApplet.newAudioClip(getClass().getResource(Constants.SOUND_DISCONNECT_FILE)).play();
     
        setDefaultValues();
        
    }//GEN-LAST:event_restoreDefaultButActionPerformed
    
                
    private void FPvectorsInformationsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPvectorsInformationsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPvectorsInformationsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPvectorsInformationsFileNameTxtMouseClicked
    
    private void testFilesDirectoryTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_testFilesDirectoryTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = testFilesDirectoryTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_testFilesDirectoryTxtMouseClicked
    
    private void activeLearningFilesDirectoryTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_activeLearningFilesDirectoryTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = activeLearningFilesDirectoryTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_activeLearningFilesDirectoryTxtMouseClicked
        
    private void listsDirectoryTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listsDirectoryTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = listsDirectoryTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_listsDirectoryTxtMouseClicked
    
    private void SPORGambiguousVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPORGambiguousVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPORGambiguousVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPORGambiguousVectorsFileNameTxtMouseClicked
    
    private void SPPERambiguousVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPPERambiguousVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPPERambiguousVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPPERambiguousVectorsFileNameTxtMouseClicked
    
    private void SPusedVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPusedVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPusedVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPusedVectorsFileNameTxtMouseClicked
    
    private void FPORGambiguousVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPORGambiguousVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPORGambiguousVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPORGambiguousVectorsFileNameTxtMouseClicked
    
    private void FPPERambiguousVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPPERambiguousVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPPERambiguousVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPPERambiguousVectorsFileNameTxtMouseClicked
    
    private void FPusedVectorsFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPusedVectorsFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPusedVectorsFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPusedVectorsFileNameTxtMouseClicked
    
    private void SPOrgClassifierFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPOrgClassifierFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPOrgClassifierFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPOrgClassifierFileNameTxtMouseClicked
    
    private void FPOrgClassifierFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPOrgClassifierFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPOrgClassifierFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPOrgClassifierFileNameTxtMouseClicked
    
    private void SPPerClassifierFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SPPerClassifierFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = SPPerClassifierFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_SPPerClassifierFileNameTxtMouseClicked
    
    private void FPPerClassifierFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FPPerClassifierFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = FPPerClassifierFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_FPPerClassifierFileNameTxtMouseClicked
    
    private void sentenceSplitterModelFileNameTxtMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_sentenceSplitterModelFileNameTxtMouseClicked
        
        browsePathBut.setEnabled(true);
        pathToBrowse = sentenceSplitterModelFileNameTxt;
        if(evt.getClickCount()==2) browsePathBut.doClick();
        
    }//GEN-LAST:event_sentenceSplitterModelFileNameTxtMouseClicked
    
    private void classifiersPathPnlMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_classifiersPathPnlMouseClicked
        
    }//GEN-LAST:event_classifiersPathPnlMouseClicked
    
    private void batchSizeTxtKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_batchSizeTxtKeyTyped
        
        try {
            
            Integer.parseInt(this.batchSizeTxt.getText());
            
        }catch(NumberFormatException NFEx){
            
            JOptionPane.showMessageDialog(null,
                    "<html>" +
                    "You have typed an Elligal format of " +
                    "<br>integer in batch size text. batch size is set" +
                    "<br>to default value 100" +
                    "<html/>");
            
        }
        
    }//GEN-LAST:event_batchSizeTxtKeyTyped
    
    private void okBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBActionPerformed
        
        try {
            Applet.newAudioClip(new File(Constants.SOUND_CLICK_01_FILE).toURI().toURL()).play();
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
        }
        
        setVisible(false);
        batchSize = Integer.parseInt(batchSizeTxt.getText());
        // loads paths
        actLeFrm.loadParams(this);
        
    }//GEN-LAST:event_okBActionPerformed
    
    private void browsePathButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browsePathButActionPerformed
        
        JApplet.newAudioClip(getClass().getResource(Constants.SOUND_CLICK_01_FILE)).play();
        
        File f = new File(this.pathToBrowse.getText());
        if (f.exists()&& pathToBrowse.isEnabled()){
            
            if(f.isDirectory()){
                jfch.setCurrentDirectory(f);
                doOnBrowseClickDir(this.pathToBrowse);
            } else{
                jfch.setCurrentDirectory(f.getParentFile());
                doOnBrowseClickFile(this.pathToBrowse);
            }
        }
        
        browsePathBut.setEnabled(false);
        
    }//GEN-LAST:event_browsePathButActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JTextField FPORGambiguousVectorsFileNameTxt;
    protected javax.swing.JTextField FPOrgClassifierFileNameTxt;
    javax.swing.JTextField FPPERambiguousVectorsFileNameTxt;
    protected javax.swing.JTextField FPPerClassifierFileNameTxt;
    javax.swing.JTextField FPusedVectorsFileNameTxt;
    javax.swing.JTextField FPvectorsInformationsFileNameTxt;
    javax.swing.JTextField SPORGambiguousVectorsFileNameTxt;
    protected javax.swing.JTextField SPOrgClassifierFileNameTxt;
    javax.swing.JTextField SPPERambiguousVectorsFileNameTxt;
    protected javax.swing.JTextField SPPerClassifierFileNameTxt;
    javax.swing.JTextField SPusedVectorsFileNameTxt;
    javax.swing.JTextField SPvectorsInformationsFileNameTxt;
    private javax.swing.ButtonGroup actLeMethodGrp;
    javax.swing.JTextField activeLearningFilesDirectoryTxt;
    protected javax.swing.JTextField batchSizeTxt;
    private javax.swing.JButton browsePathBut;
    protected javax.swing.JPanel classifiersPathPnl;
    private javax.swing.ButtonGroup howToFindPoolGrp;
    private javax.swing.ButtonGroup howToFindTestGrp;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel5;
    javax.swing.JTextField listsDirectoryTxt;
    private javax.swing.JButton okB;
    protected javax.swing.JTabbedPane paramTabs;
    protected javax.swing.JPanel restPnl;
    private javax.swing.JButton restoreDefaultBut;
    protected javax.swing.JPanel secondPassPanl;
    javax.swing.JTextField sentenceSplitterModelFileNameTxt;
    javax.swing.JTextField testFilesDirectoryTxt;
    // End of variables declaration//GEN-END:variables
    javax.swing.JTextField pathToBrowse ;
    
}//ParamFrame
