/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2007  X.Vassilakos
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.gui.main;

import ipl.util.Constants;
import java.awt.CardLayout;
import java.awt.LayoutManager;
import javax.swing.JApplet;

/**
 *
 * @author  Xen.Vassilakos
 */
public class SetCGammaForm extends javax.swing.JFrame {
    
    /** Creates new form SetCGammaForm */
    public SetCGammaForm() {
        
        initComponents();
        /*
        try {
         
            Constants.playSound(Constants.SOUND_ALERT_01_FILE);
            File warnIcon = new File(Constants.IMA_WARN_03);
            ImageIcon ima = new ImageIcon(warnIcon.toURI().toURL());
            String mes = "Any changes to c and gamma parameter values are critical\n" +
                    "and must be revised carefully, only after performing the tuning process!";
            JOptionPane.showMessageDialog(this, mes, "Warning!", JOptionPane.WARNING_MESSAGE, ima);
        } catch (HeadlessException ex) {
            ex.printStackTrace();
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
        }
         */
        
        // Person
        cTxtPer.setText(String.valueOf(Constants.PER_C_FP));
        cTxtSpPer.setText(String.valueOf(Constants.PER_C_SP));
        gammaTxtPer.setText(String.valueOf(Constants.PER_GAMMA_FP));
        gammaTxtSpPer.setText(String.valueOf(Constants.PER_GAMMA_SP));
        
        // Organization
        cTxtOrg.setText(String.valueOf(Constants.ORG_C_FP));
        cTxtSpOrg.setText(String.valueOf(Constants.ORG_C_SP));
        gammaTxtOrg.setText(String.valueOf(Constants.ORG_GAMMA_FP));
        gammaTxtSpOrg.setText(String.valueOf(Constants.ORG_GAMMA_SP));
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        centerPnl = new javax.swing.JPanel();
        perPnl = new javax.swing.JPanel();
        cTxtPer = new javax.swing.JTextField();
        gammaTxtPer = new javax.swing.JTextField();
        cLB = new javax.swing.JLabel();
        gammaLB = new javax.swing.JLabel();
        categLB = new javax.swing.JLabel();
        cLBSpPer = new javax.swing.JLabel();
        cTxtSpPer = new javax.swing.JTextField();
        gammaTxtSpPer = new javax.swing.JTextField();
        gammaLBSpPer = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        fpLB = new javax.swing.JLabel();
        spLB = new javax.swing.JLabel();
        undoBut = new javax.swing.JButton();
        orgPnl = new javax.swing.JPanel();
        cTxtOrg = new javax.swing.JTextField();
        gammaTxtOrg = new javax.swing.JTextField();
        cLB1 = new javax.swing.JLabel();
        gammaLB1 = new javax.swing.JLabel();
        categLB1 = new javax.swing.JLabel();
        cLBSpOrg = new javax.swing.JLabel();
        cTxtSpOrg = new javax.swing.JTextField();
        gammaTxtSpOrg = new javax.swing.JTextField();
        gammaLBsp1 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        fpLB1 = new javax.swing.JLabel();
        spLB1 = new javax.swing.JLabel();
        nthPnl = new javax.swing.JPanel();
        perTogBut = new javax.swing.JToggleButton();
        orgTogBut = new javax.swing.JToggleButton();
        sthPnl = new javax.swing.JPanel();
        cancelBut = new javax.swing.JButton();
        okBut = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Set c, gamma svm parameters");
        centerPnl.setLayout(new java.awt.CardLayout());

        centerPnl.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        perPnl.setLayout(new java.awt.GridBagLayout());

        cTxtPer.setText("c");
        cTxtPer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cTxtPerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        perPnl.add(cTxtPer, gridBagConstraints);

        gammaTxtPer.setText("gamma");
        gammaTxtPer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gammaTxtPerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        perPnl.add(gammaTxtPer, gridBagConstraints);

        cLB.setText("C:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        perPnl.add(cLB, gridBagConstraints);

        gammaLB.setText("gamma:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        perPnl.add(gammaLB, gridBagConstraints);

        categLB.setFont(new java.awt.Font("Tahoma", 1, 24));
        categLB.setText("Person");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(9, 2, 3, 2);
        perPnl.add(categLB, gridBagConstraints);

        cLBSpPer.setText("C:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        perPnl.add(cLBSpPer, gridBagConstraints);

        cTxtSpPer.setText("c");
        cTxtSpPer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cTxtSpPerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        perPnl.add(cTxtSpPer, gridBagConstraints);

        gammaTxtSpPer.setText("gamma");
        gammaTxtSpPer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gammaTxtSpPerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 11, 17);
        perPnl.add(gammaTxtSpPer, gridBagConstraints);

        gammaLBSpPer.setText("gamma:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 11, 0);
        perPnl.add(gammaLBSpPer, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        perPnl.add(jSeparator1, gridBagConstraints);

        fpLB.setFont(new java.awt.Font("Tahoma", 1, 18));
        fpLB.setText("First Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(18, 10, 4, 0);
        perPnl.add(fpLB, gridBagConstraints);

        spLB.setFont(new java.awt.Font("Tahoma", 1, 18));
        spLB.setText("Second Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 4, 0);
        perPnl.add(spLB, gridBagConstraints);

        undoBut.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/default_val01.jpg")));
        undoBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                undoButActionPerformed(evt);
            }
        });

        perPnl.add(undoBut, new java.awt.GridBagConstraints());

        centerPnl.add(perPnl, "per");

        orgPnl.setLayout(new java.awt.GridBagLayout());

        cTxtOrg.setText("c");
        cTxtOrg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cTxtOrgActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 58;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        orgPnl.add(cTxtOrg, gridBagConstraints);

        gammaTxtOrg.setText("gamma");
        gammaTxtOrg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gammaTxtOrgActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 58;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        orgPnl.add(gammaTxtOrg, gridBagConstraints);

        cLB1.setText("C:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        orgPnl.add(cLB1, gridBagConstraints);

        gammaLB1.setText("gamma:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        orgPnl.add(gammaLB1, gridBagConstraints);

        categLB1.setFont(new java.awt.Font("Tahoma", 1, 24));
        categLB1.setText("Organization");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(9, 2, 3, 2);
        orgPnl.add(categLB1, gridBagConstraints);

        cLBSpOrg.setText("C:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        orgPnl.add(cLBSpOrg, gridBagConstraints);

        cTxtSpOrg.setText("c");
        cTxtSpOrg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cTxtSpOrgActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 58;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 17);
        orgPnl.add(cTxtSpOrg, gridBagConstraints);

        gammaTxtSpOrg.setText("gamma");
        gammaTxtSpOrg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gammaTxtSpOrgActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 58;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 9, 17);
        orgPnl.add(gammaTxtSpOrg, gridBagConstraints);

        gammaLBsp1.setText("gamma:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 9, 0);
        orgPnl.add(gammaLBsp1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        orgPnl.add(jSeparator2, gridBagConstraints);

        fpLB1.setFont(new java.awt.Font("Tahoma", 1, 18));
        fpLB1.setText("First Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(16, 10, 16, 0);
        orgPnl.add(fpLB1, gridBagConstraints);

        spLB1.setFont(new java.awt.Font("Tahoma", 1, 18));
        spLB1.setText("Second Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 3.0;
        gridBagConstraints.insets = new java.awt.Insets(24, 10, 16, 0);
        orgPnl.add(spLB1, gridBagConstraints);

        centerPnl.add(orgPnl, "org");

        getContentPane().add(centerPnl, java.awt.BorderLayout.CENTER);

        nthPnl.setLayout(new java.awt.GridBagLayout());

        nthPnl.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Choose category:", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION));
        buttonGroup1.add(perTogBut);
        perTogBut.setMnemonic('p');
        perTogBut.setSelected(true);
        perTogBut.setText("Person");
        perTogBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                perTogButActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(7, 10, 2, 10);
        nthPnl.add(perTogBut, gridBagConstraints);

        buttonGroup1.add(orgTogBut);
        orgTogBut.setMnemonic('o');
        orgTogBut.setText("Organization");
        orgTogBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                orgTogButActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(7, 10, 2, 10);
        nthPnl.add(orgTogBut, gridBagConstraints);

        getContentPane().add(nthPnl, java.awt.BorderLayout.NORTH);

        sthPnl.setLayout(new java.awt.GridBagLayout());

        cancelBut.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/wrong.gif")));
        cancelBut.setToolTipText("Undo changes to values.");
        cancelBut.setBorder(null);
        cancelBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 4, 10, 4);
        sthPnl.add(cancelBut, gridBagConstraints);

        okBut.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/ok_02.gif")));
        okBut.setToolTipText("save changes and close form");
        okBut.setBorder(null);
        okBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 4, 10, 4);
        sthPnl.add(okBut, gridBagConstraints);

        getContentPane().add(sthPnl, java.awt.BorderLayout.SOUTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-373)/2, (screenSize.height-379)/2, 373, 379);
    }// </editor-fold>//GEN-END:initComponents
    
    private void undoButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_undoButActionPerformed
// Person
        cTxtPer.setText(String.valueOf(Constants.DEFAULT_PER_C_FP));
        cTxtSpPer.setText(String.valueOf(Constants.DEFAULT_PER_C_SP));
        gammaTxtPer.setText(String.valueOf(Constants.DEFAULT_PER_GAMMA_FP));
        gammaTxtSpPer.setText(String.valueOf(Constants.DEFAULT_PER_GAMMA_SP));
        
        // Organization
        cTxtOrg.setText(String.valueOf(Constants.DEFAULT_ORG_C_FP));
        cTxtSpOrg.setText(String.valueOf(Constants.DEFAULT_ORG_C_SP));
        gammaTxtOrg.setText(String.valueOf(Constants.DEFAULT_ORG_GAMMA_FP));
        gammaTxtSpOrg.setText(String.valueOf(Constants.DEFAULT_ORG_GAMMA_SP));
        
        
    }//GEN-LAST:event_undoButActionPerformed
    
    private void cancelButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButActionPerformed
        
        JApplet.newAudioClip(getClass().getResource(Constants.SOUND_DISCONNECT_FILE)).play();
        dispose();
        
        
    }//GEN-LAST:event_cancelButActionPerformed
    
    private void okButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButActionPerformed
        
        try {
            
            Constants.CHANGE_SVM_PARAM_VALUES(
                    Constants.PERSON, cTxtPer.getText(),
                    cTxtSpPer.getText(), gammaTxtPer.getText(),
                    gammaTxtSpPer.getText());
            
            Constants.CHANGE_SVM_PARAM_VALUES(
                    Constants.ORGANIZATION, cTxtOrg.getText(),
                    cTxtSpOrg.getText(), gammaTxtOrg.getText(),
                    gammaTxtSpOrg.getText());
            
        } catch (NumberFormatException ex) {
            ex.printStackTrace();
        }
        
        dispose();
        
    }//GEN-LAST:event_okButActionPerformed
    
    private void gammaTxtSpOrgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gammaTxtSpOrgActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_gammaTxtSpOrgActionPerformed
    
    private void cTxtSpOrgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cTxtSpOrgActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_cTxtSpOrgActionPerformed
    
    private void gammaTxtOrgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gammaTxtOrgActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_gammaTxtOrgActionPerformed
    
    private void cTxtOrgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cTxtOrgActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_cTxtOrgActionPerformed
    
    private void gammaTxtSpPerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gammaTxtSpPerActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_gammaTxtSpPerActionPerformed
    
    private void cTxtSpPerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cTxtSpPerActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_cTxtSpPerActionPerformed
    
    private void gammaTxtPerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gammaTxtPerActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_gammaTxtPerActionPerformed
    
    private void cTxtPerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cTxtPerActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_cTxtPerActionPerformed
    
    private void orgTogButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_orgTogButActionPerformed
        
        LayoutManager lman = centerPnl.getLayout();
        if(lman instanceof java.awt.CardLayout){
            
            CardLayout cLay = (CardLayout) lman;
            
            cLay.show(centerPnl, "org");
            
        }
        
        
    }//GEN-LAST:event_orgTogButActionPerformed
    
    private void perTogButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_perTogButActionPerformed
        
        LayoutManager lman = centerPnl.getLayout();
        if(lman instanceof java.awt.CardLayout){
            
            CardLayout cLay = (CardLayout) lman;
            
            cLay.show(centerPnl, "per");
            
        }
        
    }//GEN-LAST:event_perTogButActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SetCGammaForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JLabel cLB;
    private javax.swing.JLabel cLB1;
    private javax.swing.JLabel cLBSpOrg;
    private javax.swing.JLabel cLBSpPer;
    private javax.swing.JTextField cTxtOrg;
    private javax.swing.JTextField cTxtPer;
    private javax.swing.JTextField cTxtSpOrg;
    private javax.swing.JTextField cTxtSpPer;
    private javax.swing.JButton cancelBut;
    private javax.swing.JLabel categLB;
    private javax.swing.JLabel categLB1;
    private javax.swing.JPanel centerPnl;
    private javax.swing.JLabel fpLB;
    private javax.swing.JLabel fpLB1;
    private javax.swing.JLabel gammaLB;
    private javax.swing.JLabel gammaLB1;
    private javax.swing.JLabel gammaLBSpPer;
    private javax.swing.JLabel gammaLBsp1;
    private javax.swing.JTextField gammaTxtOrg;
    private javax.swing.JTextField gammaTxtPer;
    private javax.swing.JTextField gammaTxtSpOrg;
    private javax.swing.JTextField gammaTxtSpPer;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JPanel nthPnl;
    private javax.swing.JButton okBut;
    private javax.swing.JPanel orgPnl;
    private javax.swing.JToggleButton orgTogBut;
    private javax.swing.JPanel perPnl;
    private javax.swing.JToggleButton perTogBut;
    private javax.swing.JLabel spLB;
    private javax.swing.JLabel spLB1;
    private javax.swing.JPanel sthPnl;
    private javax.swing.JButton undoBut;
    // End of variables declaration//GEN-END:variables
    
}
