/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2007  X.Vassilakos
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.gui.passive_learning;

import ipl.nerc.Trainer;
import ipl.util.Constants;
import ipl.gui.main.Nerc;
import java.awt.Toolkit;
import java.awt.Dimension;
import java.io.File;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;


/**
 *
 * @author   
 */
public class ParamsForm extends javax.swing.JFrame {
    
    
    /**
     * The main pasive learning frame that created this object
     */
    private final Form pasLeFrm;
    private JFileChooser jfch;
    
    
    /** Creates new form parametersFrame */
    public ParamsForm(Form pasLeFrmIn) {
        
        initComponents();
        
        pasLeFrm = pasLeFrmIn;
        Dimension frmDimens = (Toolkit.getDefaultToolkit()).getScreenSize();
        int x = (frmDimens.width - 670) / 2;
        int y = (frmDimens.height - 440) / 2;
        // setBounds(x, y, 640, 400);
        // setResizable(false);
        setTitle("Parameters");
        
        try {
            
            FPPerClassifierFileNameTxt.setText(new File(Constants.FP_PERSON_CLASSIFIER_FILE_PATH).getCanonicalPath());
            SPPerClassifierFileNameTxt.setText(new File(Constants.SP_PERSON_CLASSIFIER_FILE_PATH).getCanonicalPath());
            FPOrgClassifierFileNameTxt.setText(new File(Constants.FP_ORGANIZATION_CLASSIFIER_FILE_PATH).getCanonicalPath());
            SPOrgClassifierFileNameTxt.setText(new File(Constants.SP_ORGANIZATION_CLASSIFIER_FILE_PATH).getCanonicalPath());
            listsDirectoryTxt.setText(new File(Constants.LISTS_DIRECTORY_PATH).getCanonicalPath());
            periodSeparatorModelFileNameTxt.setText(new File(Constants.SENTENCE_SPLITTER_CLASSIFIER_FILE_PATH).getCanonicalPath());
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        
        jfch = new JFileChooser();
        jfch.setMultiSelectionEnabled(false);
        
    }//ParamFrame constructor
    
    
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        tsestSetGrp = new javax.swing.ButtonGroup();
        classifiersPathPanl = new javax.swing.JPanel();
        restPnl = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        browse11 = new javax.swing.JButton();
        browse9 = new javax.swing.JButton();
        listsDirectoryTxt = new javax.swing.JTextField();
        periodSeparatorModelFileNameTxt = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        browse8 = new javax.swing.JButton();
        browse12 = new javax.swing.JButton();
        FPOrgClassifierFileNameTxt = new javax.swing.JTextField();
        SPOrgClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        FPPerClassifierFileNameTxt = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        SPPerClassifierFileNameTxt = new javax.swing.JTextField();
        browse14 = new javax.swing.JButton();
        browse15 = new javax.swing.JButton();

        setTitle("Parameter Settings");
        classifiersPathPanl.setLayout(new java.awt.GridBagLayout());

        classifiersPathPanl.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        restPnl.setLayout(new java.awt.GridBagLayout());

        jLabel16.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel16.setText("Lists directory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        restPnl.add(jLabel16, gridBagConstraints);

        jLabel18.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel18.setText("Sentence Splitter");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        restPnl.add(jLabel18, gridBagConstraints);

        browse11.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse11.setToolTipText("browse");
        browse11.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse11ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(12, 6, 0, 10);
        restPnl.add(browse11, gridBagConstraints);
        browse11.getAccessibleContext().setAccessibleDescription("");

        browse9.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse9.setToolTipText("browse");
        browse9.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse9ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(12, 6, 0, 10);
        restPnl.add(browse9, gridBagConstraints);
        browse9.getAccessibleContext().setAccessibleDescription("");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        restPnl.add(listsDirectoryTxt, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        restPnl.add(periodSeparatorModelFileNameTxt, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        classifiersPathPanl.add(restPnl, gridBagConstraints);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/ok_02.gif")));
        jButton1.setToolTipText("OK");
        jButton1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 102, 51)), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(19, 20, 3, 3);
        classifiersPathPanl.add(jButton1, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel8.setText("ORGANIZATION classifier for second pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(jLabel8, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel9.setText("ORGANIZATION classifier for first pass");
        jLabel9.setToolTipText("As Defind for First Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(jLabel9, gridBagConstraints);

        browse8.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse8.setToolTipText("browse/\u03b1\u03bd\u03b1\u03b6\u03ae\u03c4\u03b7\u03c3\u03b7");
        browse8.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse8ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 2);
        classifiersPathPanl.add(browse8, gridBagConstraints);

        browse12.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse12.setToolTipText("browse/\u03b1\u03bd\u03b1\u03b6\u03ae\u03c4\u03b7\u03c3\u03b7");
        browse12.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse12ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 2);
        classifiersPathPanl.add(browse12, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(FPOrgClassifierFileNameTxt, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(SPOrgClassifierFileNameTxt, gridBagConstraints);

        jLabel10.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel10.setText("PERSON classifier for first pass");
        jLabel10.setToolTipText("As Defind for First Pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(jLabel10, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(FPPerClassifierFileNameTxt, gridBagConstraints);

        jLabel11.setFont(new java.awt.Font("Courier New", 0, 12));
        jLabel11.setText("PERSON classifier for second pass");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(jLabel11, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 80;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        classifiersPathPanl.add(SPPerClassifierFileNameTxt, gridBagConstraints);

        browse14.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse14.setToolTipText("browse/\u03b1\u03bd\u03b1\u03b6\u03ae\u03c4\u03b7\u03c3\u03b7");
        browse14.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse14ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 2);
        classifiersPathPanl.add(browse14, gridBagConstraints);

        browse15.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/browse_small.GIF")));
        browse15.setToolTipText("browse/\u03b1\u03bd\u03b1\u03b6\u03ae\u03c4\u03b7\u03c3\u03b7");
        browse15.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0))), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED)));
        browse15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse15ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 2);
        classifiersPathPanl.add(browse15, gridBagConstraints);

        getContentPane().add(classifiersPathPanl, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-655)/2, (screenSize.height-347)/2, 655, 347);
    }// </editor-fold>//GEN-END:initComponents
    
    private void browse12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse12ActionPerformed
        doOnBrowseClickFile(FPOrgClassifierFileNameTxt);
    }//GEN-LAST:event_browse12ActionPerformed
    
    private void browse14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse14ActionPerformed
        doOnBrowseClickFile(SPPerClassifierFileNameTxt);
    }//GEN-LAST:event_browse14ActionPerformed
    
    private void browse15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse15ActionPerformed
        doOnBrowseClickFile(FPPerClassifierFileNameTxt);
    }//GEN-LAST:event_browse15ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        
        setVisible(false);
        // loads paths
        pasLeFrm.loadParamPaths(this);
        
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    private void browse8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse8ActionPerformed
        doOnBrowseClickFile(SPOrgClassifierFileNameTxt);
    }//GEN-LAST:event_browse8ActionPerformed
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    private void browse11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse11ActionPerformed
        doOnBrowseClickFile(periodSeparatorModelFileNameTxt);
    }//GEN-LAST:event_browse11ActionPerformed
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    private void browse9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browse9ActionPerformed
        doOnBrowseClickDir(listsDirectoryTxt);
    }//GEN-LAST:event_browse9ActionPerformed
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    
    /**
     * Method to be called from other methods, performing pasions when a browse
     * button is clicked by the user, in order to load  a path for a file
     */
    private void doOnBrowseClickFile(JTextField txt) {
        
        jfch.setFileSelectionMode(jfch.FILES_ONLY);
        File f=new File(txt.getText());
        
        if (f.exists()){
            
            if(f.isDirectory())
                jfch.setCurrentDirectory(f);
            else
                jfch.setCurrentDirectory(f.getParentFile());
            
        }else
            JOptionPane.showMessageDialog(
                    null,f.toString()+
                    " does not exist","File does not exist",
                    JOptionPane.INFORMATION_MESSAGE);
        
        if(jfch.APPROVE_OPTION==jfch.showDialog(null,"Set file"))
            txt.setText(jfch.getSelectedFile().toString());
        
    }//doOnBrowseClickFile
    
    /**
     * Method to be called from other methods, performing pasions when a browse
     * button is clicked by the user, in order to load  a path for a Directory
     */
    
    private void doOnBrowseClickDir(JTextField txt){
        
        jfch.setFileSelectionMode(jfch.DIRECTORIES_ONLY);
        
        File f=new File(txt.getText());
        
        if (f.exists()){
            
            if(f.isDirectory())
                jfch.setCurrentDirectory(f);
            else
                jfch.setCurrentDirectory(f.getParentFile());
            
        } else JOptionPane.showMessageDialog(null,f.toString()+
                " does not exist","",JOptionPane.INFORMATION_MESSAGE);
        
        if(jfch.APPROVE_OPTION==jfch.showDialog(null,"Set Directory")){
            txt.setText(jfch.getSelectedFile().toString());
            
        }
    }//doOnBrowseClickDir
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JTextField FPOrgClassifierFileNameTxt;
    javax.swing.JTextField FPPerClassifierFileNameTxt;
    javax.swing.JTextField SPOrgClassifierFileNameTxt;
    javax.swing.JTextField SPPerClassifierFileNameTxt;
    private javax.swing.JButton browse11;
    private javax.swing.JButton browse12;
    private javax.swing.JButton browse14;
    private javax.swing.JButton browse15;
    private javax.swing.JButton browse8;
    private javax.swing.JButton browse9;
    protected javax.swing.JPanel classifiersPathPanl;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    javax.swing.JTextField listsDirectoryTxt;
    javax.swing.JTextField periodSeparatorModelFileNameTxt;
    protected javax.swing.JPanel restPnl;
    private javax.swing.ButtonGroup tsestSetGrp;
    // End of variables declaration//GEN-END:variables
    
}//ParamFrame
