/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2007  X.Vassilakos
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.nerc.active_learning.data;

import java.io.Serializable;


/**
 * This class represents a feature vector of a token which is used in a former
 * active learning experiments. 
 */ 
public class UsedVector implements Serializable {
    /**Name of the file of the allready used token*/
    private String fileName;
    /**Position of the used token in the file*/
    private int position;
    /**
     * Constructor 
     * 
     * @param fileName
     *      Name of the file of the used token
     * @param position
     *      Position of the used token in the file
     */
    public UsedVector(String fileName, int position) {
       
        this.fileName = fileName;
        this.position = position;
        
    } // constructor: UsedVector

    public String getFileName() {
        return fileName;
    }

    public int getPosition() {
        return position; 
    }
    
} // end of UsedVector
 