/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2005  G. Lucarelli
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.nerc.regex;

import java.util.ArrayList;

import ipl.core.Tokenizer;

/**
 * <p>Description: Abstract class. Contains the patterns.</p>
 *
 * <p>Copyright (c) 2005</p>
 * @version 0.1
 */
public abstract class Regex {
    
    protected ArrayList<PatternNode> regexList;
    
    public Regex() {
        regexList = new ArrayList<PatternNode>();
    } // constructor: Regex
    
    public abstract int match(Tokenizer tokenizer, int start);
    
} // end of class Regex
