/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2005  G. Lucarelli
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.util;

import java.io.*;

import ipl.util.file_manager.DirectoryManager;
import ipl.util.Constants;

public class CountMarked {
    
    private static int countType(String text, String type) {
        int index = 0;
        int count = 0;
        
        while ((index = text.indexOf(type, index + 1)) != -1) {
            count++;
        } // while
        
        return count;
    } // coutType
    
    public static void main(String args[]) throws IOException {
        int person = 0, p;
        int organization = 0, o;
        int location = 0, l;
        int money = 0, m;
        int percent = 0, pe;
        int date = 0, d;
        int time = 0, t;
        
        byte [] buff;
        String input;
        FileInputStream fis;
        File file;
//    DirectoryManager dirMan = new DirectoryManager("D:/Diplwmatiki/GREEK_NERC/files");
        DirectoryManager dirMan = new DirectoryManager("D:/Diplwmatiki/GREEK_NERC/NER_Corpus_Greek");
        
        while ((file = dirMan.getNextFile()) != null) {
            if (file.isFile()) {
//        System.out.println("\n" + file.getName());
                fis = new FileInputStream(file);
                buff = new byte[ (int) file.length()];
                fis.read(buff);
                input = new String(buff);
                
                p = countType(input, Constants.PERSON_START_TAG);
                person += p;
//        System.out.println("person: " + p);
                
                o = countType(input, Constants.ORGANIZATION_START_TAG);
                organization += o;
//        System.out.println("organization: " + o);
                
                l = countType(input, Constants.LOCATION_START_TAG);
                location += l;
//        System.out.println("location: " + l);
                
                m = countType(input, Constants.MONEY_START_TAG);
                money += m;
//        System.out.println("money: " + m);
                
                pe = countType(input, Constants.PERCENT_START_TAG);
                percent += pe;
//        System.out.println("percent: " + pe);
                
                d = countType(input, Constants.DATE_START_TAG);
                date += d;
//        System.out.println("date: " + d);
                
                t = countType(input, Constants.TIME_START_TAG);
                time += t;
//        System.out.println("time: " + t);
                
                fis.close();
            } // if
        } // while
        
        System.out.println("\n\n\nTOTAL");
        System.out.println("--------------------");
        System.out.println("person: " + person);
        System.out.println("organization: " + organization);
        System.out.println("location: " + location);
        System.out.println("money: " + money);
        System.out.println("percent: " + percent);
        System.out.println("date: " + date);
        System.out.println("time: " + time);
        
    } // end of main
    
} // end of class CountMarked
