/**
 * Greek Named Entity Recognizer.
 * Copyright (C) 2007  X.Vassilakos
 *
 * This file is part of Greek Named Entity Recognizer.
 *
 * Sentence Splitter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sentence Splitter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package ipl.util;

/**
 *
 * @author Xen.Vassilakos
 */
public class NativeTrainer {
    
    
    /////////////////////////////////////////////////////////////////////////////////////
    /////// loading dynamic library link (dll) file for svm training, test e.t.c. ///////
    static {
    
        System.loadLibrary("./lib/native/svm_trainer");
       
  
    } // static
    
      
   
    /** 
     * Native method for training the classifier.
     *
     * @param input
     *      Path to file containing training vectors
     * 
     * @param inputsize
     *      Size of input[]
     * 
     * @param output
     *      Path to output file for saving model of classifier crated after training
     * 
     * @param max_index
     *      Maximum number of training vector's features 
     * 
     * @param Probability_model
     *      Use (true) or do not use (false) a probability model
     * 
     * @param c
     *      c parameter for training svm
     * 
     * @param gamma
     *      gamma parameter for training svm
     */
    public static native void train(char[] input, int inputsize, char[] output,
            int outputsize, int max_index, boolean probability_model, double c, double gamma
            );
    
    /**
     * Creates a new instance of NativeTrainer
     */
    private NativeTrainer() {
    }
    
    
}
