package ipl.util.file_manager;

import ipl.util.Constants;
import ipl.nerc.preprocessing.TextPreprocessor;
import java.applet.Applet;
import java.io.*;
import java.util.StringTokenizer;
/**
 *           
 * <i>"       "</i> 
 *          
 *        " "
 *    .
 * <br>
 * <b>     .</b>
 *
 * <p>:        <i>FileManager
 * </i>         ,
 *       WEKA.</p>
 *
 * <p>Copyright (c) 2005</p>
 * @author  
 * @version 1.0
 */
public class ArffFileManager extends FileManager {
    
    /**
     *       ,   
     *  <i>fos</i>  .
     *
     * @param file String
     */
    public ArffFileManager(String file) {
        super(file);
    } // constructor: ArffFileManager
    
    /**
     *       :
     * <br><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; @attribute name {values[0], values[1], ...}
     *
     * @param name String
     * @param values String[]
     */
    private void setAttributeHeader(String name, String[] values) {
        String attrHeader = "@attribute " + name + " {";
        for (int i = 0; i < values.length; i++) {
            attrHeader = attrHeader + values[i];
            if (i != values.length - 1) {
                attrHeader = attrHeader + ",";
            } // if
        } // for
        attrHeader = attrHeader + "}\n";
        
        try {
            fos.write(attrHeader.getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setAttributeHeader
    
    /**
     *       :
     * <br><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; @attribute name type
   
     * @param name String
     * @param type String
     */
    private void setAttributeHeader(String name, String type) {
        String attrHeader = "@attribute " + name + " " + type + "\n";
        try {
            fos.write(attrHeader.getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setAttributeHeader
    
    /**
     *        .
     *            .
     *
     * @param header String
     */
    public void setHeader(String header) {
        try {
            fos.write(header.getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setHeader
    
    /**
     *           
     *      PERSON.
     * <br><br>
     *    <i>mark</i>       
     *   ('   )    .
     * <br><br>
     *    <i>firstPass</i>       
     *       .   
     *   .
     *
     * @param mark boolean
     * @param firstPass boolean
     */
    public void setHeaderForPerson(boolean mark, boolean firstPass) {
        try {
            fos.write("@relation nerc\n".getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
        
        // -3
        setAttributeHeader("---isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("---length", "real");
        setAttributeHeader("---isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("---isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("---grEnding", new String[]{"-1","1"});
        setAttributeHeader("---isGrWord", new String[]{"-1","1"});
        setAttributeHeader("---isEnWord", new String[]{"-1","1"});
        setAttributeHeader("---isNumber", new String[]{"-1","1"});
        setAttributeHeader("---inPlural", new String[]{"-1","1"});
        setAttributeHeader("---isDot", new String[]{"-1","1"});
        setAttributeHeader("---isComma", new String[]{"-1","1"});
        setAttributeHeader("---isAdjective", new String[]{"-1","1"});
        setAttributeHeader("---grPrefix", new String[]{"-1","1"});
        setAttributeHeader("---grSuffix", new String[]{"-1","1"});
        setAttributeHeader("---greekNamesList", "real");
        setAttributeHeader("---insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("---inGenetive", new String[]{"-1","1"});
        setAttributeHeader("---sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("---ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("---afoi", new String[]{"-1","1"});
        setAttributeHeader("---clf", "real");
        setAttributeHeader("---isSlash", new String[]{"-1","1"});
        setAttributeHeader("---isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("---perFPProbability", "real");
            setAttributeHeader("---orgFPProbability", "real");
            
            setAttributeHeader("---inPerFPSureList", "real");
            setAttributeHeader("---inOrgFPSureList", "real");
            
            setAttributeHeader("---distFromPrevPerFP", "real");
            setAttributeHeader("---distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("---distFromFollowingPerFP", "real");
            setAttributeHeader("---distFromFollowingOrgFP", "real");
            
        } // if
        
        // -2
        setAttributeHeader("--isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("--length", "real");
        setAttributeHeader("--isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("--isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("--grEnding", new String[]{"-1","1"});
        setAttributeHeader("--isGrWord", new String[]{"-1","1"});
        setAttributeHeader("--isEnWord", new String[]{"-1","1"});
        setAttributeHeader("--isNumber", new String[]{"-1","1"});
        setAttributeHeader("--inPlural", new String[]{"-1","1"});
        setAttributeHeader("--isDot", new String[]{"-1","1"});
        setAttributeHeader("--isComma", new String[]{"-1","1"});
        setAttributeHeader("--isAdjective", new String[]{"-1","1"});
        setAttributeHeader("--grPrefix", new String[]{"-1","1"});
        setAttributeHeader("--grSuffix", new String[]{"-1","1"});
        setAttributeHeader("--greekNamesList", "real");
        setAttributeHeader("--insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("--inGenetive", new String[]{"-1","1"});
        setAttributeHeader("--sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("--ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("--afoi", new String[]{"-1","1"});
        setAttributeHeader("--clf", "real");
        // setAttributeHeader("--isSlash", new String[]{"-1","1"});
        setAttributeHeader("--isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("--perFPProbability", "real");
            setAttributeHeader("--orgFPProbability", "real");
            
            setAttributeHeader("--inPerFPSureList", "real");
            setAttributeHeader("--inOrgFPSureList", "real");
            
            setAttributeHeader("--distFromPrevPerFP", "real");
            setAttributeHeader("--distFromPrevOrgFP", "real");
            
            setAttributeHeader("--distFromFollowingPerFP", "real");
            setAttributeHeader("--distFromFollowingOrgFP", "real");
            
        } // if
        
        // -1
        setAttributeHeader("-isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("-length", "real");
        setAttributeHeader("-isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("-isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("-grEnding", new String[]{"-1","1"});
        setAttributeHeader("-isGrWord", new String[]{"-1","1"});
        setAttributeHeader("-isEnWord", new String[]{"-1","1"});
        setAttributeHeader("-isNumber", new String[]{"-1","1"});
        setAttributeHeader("-inPlural", new String[]{"-1","1"});
        setAttributeHeader("-isDot", new String[]{"-1","1"});
        setAttributeHeader("-isComma", new String[]{"-1","1"});
        setAttributeHeader("-isAdjective", new String[]{"-1","1"});
        setAttributeHeader("-grPrefix", new String[]{"-1","1"});
        setAttributeHeader("-grSuffix", new String[]{"-1","1"});
        setAttributeHeader("-greekNamesList", "real");
        setAttributeHeader("-insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("-inGenetive", new String[]{"-1","1"});
        setAttributeHeader("-sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("-ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("-afoi", new String[]{"-1","1"});
        setAttributeHeader("-clf", "real");
        setAttributeHeader("-isSlash", new String[]{"-1","1"});
        setAttributeHeader("-isDash", new String[]{"-1","1"});
        
        if (!firstPass) {
            
            setAttributeHeader("-perFPProbability", "real");
            setAttributeHeader("-orgFPProbability", "real");
            
            setAttributeHeader("-inPerFPSureList", "real");
            setAttributeHeader("-inOrgFPSureList", "real");
            
            setAttributeHeader("-distFromPrevPerFP", "real");
            setAttributeHeader("-distFromPrevOrgFP", "real");
            
            setAttributeHeader("-distFromFollowingPerFP", "real");
            setAttributeHeader("-distFromFollowingOrgFP", "real");
            
        } // if
        
        // 0
        setAttributeHeader("isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("length", "real");
        setAttributeHeader("isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("grEnding", new String[]{"-1","1"});
        setAttributeHeader("isGrWord", new String[]{"-1","1"});
        setAttributeHeader("isEnWord", new String[]{"-1","1"});
        // setAttributeHeader("isNumber", new String[]{"-1","1"});
        setAttributeHeader("inPlural", new String[]{"-1","1"});
        setAttributeHeader("isDot", new String[]{"-1","1"});
        setAttributeHeader("isComma", new String[]{"-1","1"});
        setAttributeHeader("isAdjective", new String[]{"-1","1"});
        setAttributeHeader("grPrefix", new String[]{"-1","1"});
        setAttributeHeader("grSuffix", new String[]{"-1","1"});
        setAttributeHeader("greekNamesList", "real");
        setAttributeHeader("insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("inGenetive", new String[]{"-1","1"});
        setAttributeHeader("sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("afoi", new String[]{"-1","1"});
        setAttributeHeader("clf", "real");
        // setAttributeHeader("isSlash", new String[]{"-1","1"});
        setAttributeHeader("isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("perFPProbability", "real");
            setAttributeHeader("orgFPProbability", "real");
            
            setAttributeHeader("inPerFPSureList", "real");
            setAttributeHeader("inOrgFPSureList", "real");
            
            setAttributeHeader("distFromPrevPerFP", "real");
            setAttributeHeader("distFromPrevOrgFP", "real");
            
            setAttributeHeader("distFromFollowingPerFP", "real");
            setAttributeHeader("distFromFollowingOrgFP", "real");
            
        } // if
        
        // +1
        setAttributeHeader("+isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("+length", "real");
        setAttributeHeader("+isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("+isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("+grEnding", new String[]{"-1","1"});
        setAttributeHeader("+isGrWord", new String[]{"-1","1"});
        setAttributeHeader("+isEnWord", new String[]{"-1","1"});
        setAttributeHeader("+isNumber", new String[]{"-1","1"});
        setAttributeHeader("+inPlural", new String[]{"-1","1"});
        setAttributeHeader("+isDot", new String[]{"-1","1"});
        setAttributeHeader("+isComma", new String[]{"-1","1"});
        setAttributeHeader("+isAdjective", new String[]{"-1","1"});
        setAttributeHeader("+grPrefix", new String[]{"-1","1"});
        setAttributeHeader("+grSuffix", new String[]{"-1","1"});
        setAttributeHeader("+greekNamesList", "real");
        setAttributeHeader("+insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("+inGenetive", new String[]{"-1","1"});
        setAttributeHeader("+sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("+ypoyrg-xrhm", new String[]{"-1","1"});
        //setAttributeHeader("+afoi", new String[]{"-1","1"});
        //setAttributeHeader("+clf", "real");
        setAttributeHeader("+isSlash", new String[]{"-1","1"});
        setAttributeHeader("+isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("+perFPProbability", "real");
            setAttributeHeader("+orgFPProbability", "real");
            
            setAttributeHeader("+inPerFPSureList", "real");
            setAttributeHeader("+inOrgFPSureList", "real");
            
            setAttributeHeader("+distFromPrevPerFP", "real");
            setAttributeHeader("+distFromPrevOrgFP", "real");
            
            setAttributeHeader("+distFromFollowingPerFP", "real");
            setAttributeHeader("+distFromFollowingOrgFP", "real");
            
        } // if
        
        // +2
        setAttributeHeader("++isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("++length", "real");
        setAttributeHeader("++isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("++isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("++grEnding", new String[]{"-1","1"});
        setAttributeHeader("++isGrWord", new String[]{"-1","1"});
        setAttributeHeader("++isEnWord", new String[]{"-1","1"});
        setAttributeHeader("++isNumber", new String[]{"-1","1"});
        setAttributeHeader("++inPlural", new String[]{"-1","1"});
        setAttributeHeader("++isDot", new String[]{"-1","1"});
        setAttributeHeader("++isComma", new String[]{"-1","1"});
        setAttributeHeader("++isAdjective", new String[]{"-1","1"});
        setAttributeHeader("++grPrefix", new String[]{"-1","1"});
        setAttributeHeader("++grSuffix", new String[]{"-1","1"});
        // setAttributeHeader("++greekNamesList", "real");
        setAttributeHeader("++insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("++inGenetive", new String[]{"-1","1"});
        setAttributeHeader("++sigmaTel", new String[]{"-1","1"});
        // setAttributeHeader("++ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("++afoi", new String[]{"-1","1"});
        // setAttributeHeader("++clf", "real");
        setAttributeHeader("++isSlash", new String[]{"-1","1"});
        setAttributeHeader("++isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("++perFPProbability", "real");
            setAttributeHeader("++orgFPProbability", "real");
            
            setAttributeHeader("++inPerFPSureList", "real");
            setAttributeHeader("++inOrgFPSureList", "real");
            
            setAttributeHeader("++distFromPrevPerFP", "real");
            setAttributeHeader("++distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("++distFromFollowingPerFP", "real");
            setAttributeHeader("++distFromFollowingOrgFP", "real");
            
        } // if
        
        // +3
        setAttributeHeader("+++isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("+++length", "real");
        setAttributeHeader("+++isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("+++isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("+++grEnding", new String[]{"-1","1"});
        setAttributeHeader("+++isGrWord", new String[]{"-1","1"});
        setAttributeHeader("+++isEnWord", new String[]{"-1","1"});
        setAttributeHeader("+++isNumber", new String[]{"-1","1"});
        setAttributeHeader("+++inPlural", new String[]{"-1","1"});
        setAttributeHeader("+++isDot", new String[]{"-1","1"});
        setAttributeHeader("+++isComma", new String[]{"-1","1"});
        setAttributeHeader("+++isAdjective", new String[]{"-1","1"});
        setAttributeHeader("+++grPrefix", new String[]{"-1","1"});
        setAttributeHeader("+++grSuffix", new String[]{"-1","1"});
        setAttributeHeader("+++greekNamesList", "real");
        setAttributeHeader("+++insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("+++inGenetive", new String[]{"-1","1"});
        setAttributeHeader("+++sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("+++ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("+++afoi", new String[]{"-1","1"});
        // setAttributeHeader("+++clf", "real");
        // setAttributeHeader("+++isSlash", new String[]{"-1","1"});
        setAttributeHeader("+++isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("+++perFPProbability", "real");
            setAttributeHeader("+++orgFPProbability", "real");
            
            setAttributeHeader("+++inPerFPSureList", "real");
            setAttributeHeader("+++inOrgFPSureList", "real");
            
            setAttributeHeader("+++distFromPrevPerFP", "real");
            setAttributeHeader("+++distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("+++distFromFollowingPerFP", "real");
            setAttributeHeader("+++distFromFollowingOrgFP", "real");
            
        } // if
        
        setAttributeHeader("mr", new String[]{"-1","1"});
        setAttributeHeader("messrs", new String[]{"-1","1"});
        
        setAttributeHeader("PERfrequencyPrevList5to20dist7", "real");
        setAttributeHeader("PERfrequencyPrevList5to20dist1", "real");
        setAttributeHeader("PERfrequencyPrevList3to4dist7", "real");
        setAttributeHeader("PERfrequencyPrevList3to4dist1", "real");
        setAttributeHeader("PERfrequencyPrevList1to2dist7", "real");
        setAttributeHeader("PERfrequencyPrevList1to2dist1", "real");
        
        // setAttributeHeader("ORGfrequencyPrevList5to20dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList5to20dist1", "real");
        setAttributeHeader("ORGfrequencyPrevList3to4dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList3to4dist1", "real");
        setAttributeHeader("ORGfrequencyPrevList1to2dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList1to2dist1", "real");
        
        setAttributeHeader("distFromStartLessThan1", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan2", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan3", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan4", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan5", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan6", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan7", new String[]{"-1","1"});
        
        // category
        if (mark) {
            setAttributeHeader("class", new String[]{"-1","1"});
        } // if
        try {
            fos.write("@data".getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setHeaderForPerson
    
    /**
     *           
     *      ORGANIZATION.
     * <br><br>
     *    <i>mark</i>       
     *   ('   )    .
     * <br><br>
     *    <i>firstPass</i>       
     *       .   
     *   .
   
     * @param mark boolean
     * @param firstPass boolean
     */
    public void setHeaderForOrganization(boolean mark, boolean firstPass) {
        
        try {
            fos.write(("@relation org" + (firstPass ? "FP": "SP") + "\n").getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
        
        // -3
        setAttributeHeader("---isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("---length", "real");
        setAttributeHeader("---isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("---isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("---grEnding", new String[]{"-1","1"});
        setAttributeHeader("---isGrWord", new String[]{"-1","1"});
        setAttributeHeader("---isEnWord", new String[]{"-1","1"});
        setAttributeHeader("---isNumber", new String[]{"-1","1"});
        setAttributeHeader("---inPlural", new String[]{"-1","1"});
        setAttributeHeader("---isDot", new String[]{"-1","1"});
        setAttributeHeader("---isComma", new String[]{"-1","1"});
        setAttributeHeader("---isAdjective", new String[]{"-1","1"});
        setAttributeHeader("---grPrefix", new String[]{"-1","1"});
        setAttributeHeader("---grSuffix", new String[]{"-1","1"});
        setAttributeHeader("---greekNamesList", "real");
        setAttributeHeader("---insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("---inGenetive", new String[]{"-1","1"});
        setAttributeHeader("---sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("---ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("---afoi", new String[]{"-1","1"});
        setAttributeHeader("---clf", "real");
        setAttributeHeader("---isSlash", new String[]{"-1","1"});
        setAttributeHeader("---isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("---perFPProbability", "real");
            setAttributeHeader("---orgFPProbability", "real");
            
            setAttributeHeader("---inPerFPSureList", "real");
            setAttributeHeader("---inOrgFPSureList", "real");
            
            setAttributeHeader("---distFromPrevPerFP", "real");
            setAttributeHeader("---distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("---distFromFollowingPerFP", "real");
            setAttributeHeader("---distFromFollowingOrgFP", "real");
            
        } // if
        
        // -2
        setAttributeHeader("--isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("--length", "real");
        setAttributeHeader("--isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("--isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("--grEnding", new String[]{"-1","1"});
        setAttributeHeader("--isGrWord", new String[]{"-1","1"});
        setAttributeHeader("--isEnWord", new String[]{"-1","1"});
        setAttributeHeader("--isNumber", new String[]{"-1","1"});
        setAttributeHeader("--inPlural", new String[]{"-1","1"});
        setAttributeHeader("--isDot", new String[]{"-1","1"});
        setAttributeHeader("--isComma", new String[]{"-1","1"});
        setAttributeHeader("--isAdjective", new String[]{"-1","1"});
        setAttributeHeader("--grPrefix", new String[]{"-1","1"});
        setAttributeHeader("--grSuffix", new String[]{"-1","1"});
        setAttributeHeader("--greekNamesList", "real");
        setAttributeHeader("--insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("--inGenetive", new String[]{"-1","1"});
        setAttributeHeader("--sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("--ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("--afoi", new String[]{"-1","1"});
        setAttributeHeader("--clf", "real");
        setAttributeHeader("--isSlash", new String[]{"-1","1"});
        setAttributeHeader("--isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("--perFPProbability", "real");
            setAttributeHeader("--orgFPProbability", "real");
            
            setAttributeHeader("--inPerFPSureList", "real");
            setAttributeHeader("--inOrgFPSureList", "real");
            
            setAttributeHeader("--distFromPrevPerFP", "real");
            setAttributeHeader("--distFromPrevOrgFP", "real");
            
            setAttributeHeader("--distFromFollowingPerFP", "real");
            setAttributeHeader("--distFromFollowingOrgFP", "real");
            
        } // if
        
        // -1
        setAttributeHeader("-isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("-length", "real");
        setAttributeHeader("-isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("-isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("-grEnding", new String[]{"-1","1"});
        setAttributeHeader("-isGrWord", new String[]{"-1","1"});
        setAttributeHeader("-isEnWord", new String[]{"-1","1"});
        setAttributeHeader("-isNumber", new String[]{"-1","1"});
        setAttributeHeader("-inPlural", new String[]{"-1","1"});
        setAttributeHeader("-isDot", new String[]{"-1","1"});
        setAttributeHeader("-isComma", new String[]{"-1","1"});
        setAttributeHeader("-isAdjective", new String[]{"-1","1"});
        setAttributeHeader("-grPrefix", new String[]{"-1","1"});
        setAttributeHeader("-grSuffix", new String[]{"-1","1"});
        setAttributeHeader("-greekNamesList", "real");
        setAttributeHeader("-insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("-inGenetive", new String[]{"-1","1"});
        setAttributeHeader("-sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("-ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("-afoi", new String[]{"-1","1"});
        setAttributeHeader("-clf", "real");
        setAttributeHeader("-isSlash", new String[]{"-1","1"});
        setAttributeHeader("-isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("-perFPProbability", "real");
            setAttributeHeader("-orgFPProbability", "real");
            
            setAttributeHeader("-inPerFPSureList", "real");
            setAttributeHeader("-inOrgFPSureList", "real");
            
            setAttributeHeader("-distFromPrevPerFP", "real");
            setAttributeHeader("-distFromPrevOrgFP", "real");
            
            setAttributeHeader("-distFromFollowingPerFP", "real");
            setAttributeHeader("-distFromFollowingOrgFP", "real");
            
        } // if
        
        // 0
        setAttributeHeader("isEndOfPeriod", new String[]{"-1","1"});
        setAttributeHeader("length", "real");
        setAttributeHeader("isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("grEnding", new String[]{"-1","1"});
        setAttributeHeader("isGrWord", new String[]{"-1","1"});
        setAttributeHeader("isEnWord", new String[]{"-1","1"});
        setAttributeHeader("isNumber", new String[]{"-1","1"});
        setAttributeHeader("inPlural", new String[]{"-1","1"});
        setAttributeHeader("isDot", new String[]{"-1","1"});
        setAttributeHeader("isComma", new String[]{"-1","1"});
        setAttributeHeader("isAdjective", new String[]{"-1","1"});
        setAttributeHeader("grPrefix", new String[]{"-1","1"});
        setAttributeHeader("grSuffix", new String[]{"-1","1"});
        setAttributeHeader("greekNamesList", "real");
        setAttributeHeader("insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("inGenetive", new String[]{"-1","1"});
        setAttributeHeader("sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("afoi", new String[]{"-1","1"});
        setAttributeHeader("clf", "real");
        setAttributeHeader("isSlash", new String[]{"-1","1"});
        setAttributeHeader("isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("perFPProbability", "real");
            setAttributeHeader("orgFPProbability", "real");
            
            setAttributeHeader("inPerFPSureList", "real");
            setAttributeHeader("inOrgFPSureList", "real");
            
            setAttributeHeader("distFromPrevPerFP", "real");
            setAttributeHeader("distFromPrevOrgFP", "real");
            
            setAttributeHeader("distFromFollowingPerFP", "real");
            setAttributeHeader("distFromFollowingOrgFP", "real");
            
        } // if
        
        // +1
        setAttributeHeader("+isEndOfPeriod", new String[]{"-1","1"});
        // setAttributeHeader("+length", "real");
        setAttributeHeader("+isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("+isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("+grEnding", new String[]{"-1","1"});
        setAttributeHeader("+isGrWord", new String[]{"-1","1"});
        setAttributeHeader("+isEnWord", new String[]{"-1","1"});
        setAttributeHeader("+isNumber", new String[]{"-1","1"});
        setAttributeHeader("+inPlural", new String[]{"-1","1"});
        setAttributeHeader("+isDot", new String[]{"-1","1"});
        setAttributeHeader("+isComma", new String[]{"-1","1"});
        setAttributeHeader("+isAdjective", new String[]{"-1","1"});
        setAttributeHeader("+grPrefix", new String[]{"-1","1"});
        setAttributeHeader("+grSuffix", new String[]{"-1","1"});
        setAttributeHeader("+greekNamesList", "real");
        setAttributeHeader("+insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("+inGenetive", new String[]{"-1","1"});
        setAttributeHeader("+sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("+ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("+afoi", new String[]{"-1","1"});
        setAttributeHeader("+clf", "real");
        setAttributeHeader("+isSlash", new String[]{"-1","1"});
        setAttributeHeader("+isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("+perFPProbability", "real");
            setAttributeHeader("+orgFPProbability", "real");
            
            setAttributeHeader("+inPerFPSureList", "real");
            setAttributeHeader("+inOrgFPSureList", "real");
            
            setAttributeHeader("+distFromPrevPerFP", "real");
            setAttributeHeader("+distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("+distFromFollowingPerFP", "real");
            setAttributeHeader("+distFromFollowingOrgFP", "real");
            
            
        } // if
        
        // +2
        setAttributeHeader("++isEndOfPeriod", new String[]{"-1","1"});
        // setAttributeHeader("++length", "real");
        setAttributeHeader("++isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("++isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("++grEnding", new String[]{"-1","1"});
        setAttributeHeader("++isGrWord", new String[]{"-1","1"});
        setAttributeHeader("++isEnWord", new String[]{"-1","1"});
        setAttributeHeader("++isNumber", new String[]{"-1","1"});
        setAttributeHeader("++inPlural", new String[]{"-1","1"});
        setAttributeHeader("++isDot", new String[]{"-1","1"});
        setAttributeHeader("++isComma", new String[]{"-1","1"});
        setAttributeHeader("++isAdjective", new String[]{"-1","1"});
        setAttributeHeader("++grPrefix", new String[]{"-1","1"});
        setAttributeHeader("++grSuffix", new String[]{"-1","1"});
        setAttributeHeader("++greekNamesList", "real");
        setAttributeHeader("++insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("++inGenetive", new String[]{"-1","1"});
        setAttributeHeader("++sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("++ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("++afoi", new String[]{"-1","1"});
        setAttributeHeader("++clf", "real");
        setAttributeHeader("++isSlash", new String[]{"-1","1"});
        setAttributeHeader("++isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("++perFPProbability", "real");
            setAttributeHeader("++orgFPProbability", "real");
            
            setAttributeHeader("++inPerFPSureList", "real");
            setAttributeHeader("++inOrgFPSureList", "real");
            
            setAttributeHeader("++distFromPrevPerFP", "real");
            setAttributeHeader("++distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("++distFromFollowingPerFP", "real");
            setAttributeHeader("++distFromFollowingOrgFP", "real");
            
        } // if
        
        // +3
        setAttributeHeader("+++isEndOfPeriod", new String[]{"-1","1"});
        // setAttributeHeader("+++length", "real");
        setAttributeHeader("+++isFirstLetterCapital", new String[]{"-1","1"});
        setAttributeHeader("+++isCapitalized", new String[]{"-1","1"});
        setAttributeHeader("+++grEnding", new String[]{"-1","1"});
        setAttributeHeader("+++isGrWord", new String[]{"-1","1"});
        setAttributeHeader("+++isEnWord", new String[]{"-1","1"});
        setAttributeHeader("+++isNumber", new String[]{"-1","1"});
        setAttributeHeader("+++inPlural", new String[]{"-1","1"});
        setAttributeHeader("+++isDot", new String[]{"-1","1"});
        setAttributeHeader("+++isComma", new String[]{"-1","1"});
        setAttributeHeader("+++isAdjective", new String[]{"-1","1"});
        setAttributeHeader("+++grPrefix", new String[]{"-1","1"});
        setAttributeHeader("+++grSuffix", new String[]{"-1","1"});
        // setAttributeHeader("+++greekNamesList", "real");
        setAttributeHeader("+++insideSubtitle", new String[]{"-1","1"});
        setAttributeHeader("+++inGenetive", new String[]{"-1","1"});
        setAttributeHeader("+++sigmaTel", new String[]{"-1","1"});
        setAttributeHeader("+++ypoyrg-xrhm", new String[]{"-1","1"});
        // setAttributeHeader("+++afoi", new String[]{"-1","1"});
        setAttributeHeader("+++clf", "real");
        // setAttributeHeader("+++isSlash", new String[]{"-1","1"});
        setAttributeHeader("+++isDash", new String[]{"-1","1"});
        if (!firstPass) {
            
            setAttributeHeader("+++perFPProbability", "real");
            setAttributeHeader("+++orgFPProbability", "real");
            
            setAttributeHeader("+++inPerFPSureList", "real");
            setAttributeHeader("+++inOrgFPSureList", "real");
            
            setAttributeHeader("+++distFromPrevPerFP", "real");
            setAttributeHeader("+++distFromPrevOrgFP", "real");
            
            
            setAttributeHeader("+++distFromFollowingPerFP", "real");
            setAttributeHeader("+++distFromFollowingOrgFP", "real");
            
        } // if
        
        setAttributeHeader("mr", new String[]{"-1","1"});
        setAttributeHeader("messrs", new String[]{"-1","1"});
        
        setAttributeHeader("PERfrequencyPrevList5to20dist7", "real");
        setAttributeHeader("PERfrequencyPrevList5to20dist1", "real");
        setAttributeHeader("PERfrequencyPrevList3to4dist7", "real");
        setAttributeHeader("PERfrequencyPrevList3to4dist1", "real");
        setAttributeHeader("PERfrequencyPrevList1to2dist7", "real");
        setAttributeHeader("PERfrequencyPrevList1to2dist1", "real");
        
        setAttributeHeader("ORGfrequencyPrevList5to20dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList5to20dist1", "real");
        setAttributeHeader("ORGfrequencyPrevList3to4dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList3to4dist1", "real");
        setAttributeHeader("ORGfrequencyPrevList1to2dist7", "real");
        setAttributeHeader("ORGfrequencyPrevList1to2dist1", "real");
        
        setAttributeHeader("distFromStartLessThan1", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan2", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan3", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan4", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan5", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan6", new String[]{"-1","1"});
        setAttributeHeader("distFromStartLessThan7", new String[]{"-1","1"});
        
        // category
        if (mark) {
            setAttributeHeader("class", new String[]{"-1","1"});
        } // if
        try {
            fos.write("@data".getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setHeaderForOrganization
    /**
     *           
     *      LOCATION.
     * <br><br>
     *    <i>mark</i>       
     *   ('   )    .
     * <br><br>
     *    <i>firstPass</i>       
     *       .   
     *   .
   
     * @param mark boolean
     * @param firstPass boolean
     */
    public void setHeaderForLocation(boolean mark, boolean firstPass) {
    } // setHeaderForLocation
    
    /**
     *           
     *      .
     * <br><br>
     *    <i>mark</i>       
     *   ('   )    .
     *
     * @param mark boolean
     */
    public void setHeaderForPeriodSeparator(boolean mark) {
        try {
            fos.write("@relation dot\n".getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
        
        String vals1[] = {"0", "1"};
        String vals2[] = {"0", "1", "2"};
        String vals3[] = {"0", "1", "2", "3"};
        String vals4[] = {"0", "1", "2", "3","4"};
        
        setAttributeHeader("greekFinal", vals4);
        setAttributeHeader("previousDotDistance", vals2);
        setAttributeHeader("nextDotDistance", vals2);
        
        setAttributeHeader("_wordType", vals4);
        setAttributeHeader("_length", vals2);
        setAttributeHeader("_capitalLetter", vals3);
        
        setAttributeHeader("+wordType", vals4);
        setAttributeHeader("+length", vals2);
        setAttributeHeader("+capitalLetter", vals3);
        
        // category
        if (mark) {
            setAttributeHeader("class", vals1);
        } // if
        try {
            fos.write("@data".getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setHeaderForPeriodSeparator
    
    /**
     *   .arff    () ,  
     *         Strings.
     *
     * @param attrVector String[]
     */
    public void setData(String[] attrVector) {
        String attributes = "\n";
        int l = attrVector.length;
        for (int i = 1; i < l; i++) {
            attributes += attrVector[i] + ",";
        } // for
        attributes += attrVector[0];
        try {
            fos.write(attributes.getBytes());
        } // try
        catch (Exception e) {
            e.printStackTrace();
        } // catch
    } // setData
    
    /**
     *          
     *   libSVM   .arff (WEKA).
     *
     * @param arffFileName String
     * @param libSVMFileName String
     */
    public static void convertToArff(String arffFileName, String libSVMFileName, String pass, String category) throws IOException {
        
        ArffFileManager arffManager = new ArffFileManager(arffFileName);
        
        if(category.equalsIgnoreCase(Constants.PERSON)){
            arffManager.setHeaderForPerson(true, pass.equalsIgnoreCase(Constants.FIRST_PASS));
        }else if(category.equalsIgnoreCase(Constants.ORGANIZATION)){
            arffManager.setHeaderForOrganization(true, pass.equalsIgnoreCase(Constants.FIRST_PASS));
        }
        
        File f = new File(libSVMFileName);
        byte[] buff = new byte[ (int) f.length()];;
        try {
            FileInputStream fis = new FileInputStream(f);
            fis.read(buff);
            fis.close();
        } // try
        catch (IOException e) {
              e.printStackTrace();
        } // catch
        String text = new String(buff);
        text = TextPreprocessor.removeNoisySpaces(text);
        StringTokenizer strTok = new StringTokenizer(text, "\n");
        System.err.println(strTok.countTokens());
        while (strTok.hasMoreTokens()) {
            String line = strTok.nextToken();
            StringTokenizer vector = new StringTokenizer(line, " :");
            String[] featvector = new String[(vector.countTokens() / 2) + 1];
            int i = 0;
            featvector[i++] = vector.nextToken();
            while (vector.hasMoreTokens()) {
                vector.nextToken();
                featvector[i++] = vector.nextToken();
            } // while
            arffManager.setData(featvector);
        } // while
        arffManager.closeFile();
        
        System.out.println("Arrf file created at:\n" +
                new File(arffFileName).getCanonicalPath());
       
    } // convertToArff
    
    
    public static void main (String[] args) throws IOException{
    
        (new File(Constants.ARRF_DIRECTORY_PATH)).mkdirs();
        
        convertToArff(
                Constants.ARRF_DIRECTORY_PATH + "/" + Constants.SP_PERSON_TRAIN_VECTORS_FILE + ".arff",
                Constants.SP_PERSON_TRAIN_VECTORS_FILE, Constants.SECOND_PASS, Constants.PERSON);
    
        convertToArff(
                Constants.ARRF_DIRECTORY_PATH + "/" + Constants.SP_ORGANIZATION_TRAIN_VECTORS_FILE + ".arff",
                Constants.SP_ORGANIZATION_TRAIN_VECTORS_FILE, Constants.SECOND_PASS, Constants.ORGANIZATION);
    
    }
    
} // end of class ArffFileManager
